module PoolMembers

  file_path = File.join(Pathname.new(__FILE__).parent.parent, 'files')
  @python_file_path = File.join(file_path, 'pythonEquallogic.py')

# Method will fetch the members with there respective pool info
  def self.get_pool_info(server, uname, pwd)
    response = `python "#{@python_file_path}" #{server} #{uname} #{pwd} storagepool`
    response
  end

  #Method will return Array of members with pool members status being online
  def self.get_storage_pool(resp, server, uname, pwd)
    response = get_pool_info(server, uname, pwd)
    env_members = resp.split("\n")
    members = get_pool_members(env_members, response)
    exist_conf_member = []
    if !members.empty?
      env_members.each do |member|
        pool = members[member]["pool"]
        status = members[member]["status"]
        if status == "online"
          exist_conf_member.push(member)
          other_members = members.select { |key, value| value["pool"] == pool }
          if !other_members.empty?
            other_members.keys.each do |value|
              exist_conf_member.push(value) if member!= value
            end
          end
        end
      end
    else
      raise Puppet::Error, "No Members exist on this Storage pools"
    end
    exist_conf_member.uniq
  end

#Method will return Hash schema structure of members with pool status
  def self.get_pool_members(env_members, response)
    i= 0
    members = {}
    response.split("\n").each do |line|
      if line =~ /(on|off)(?=.*line).*$/
        pool = line.split(" ").last
        status = $1 if line.partition(' ')[2].match /([^\s]+)/
        val = {}
        val["pool"] = pool
        val["status"] = status
        if i < env_members.length
          members[env_members[i]] = val
          i+=1
        end
      end
    end
    members
  end
end
